#include <u.h>
#include <libc.h>

#define NESEG	64

char test_desc[] = "Testing that segments of class shared are shared across rfork.";

void main(int argc, char *argv[]){
  char *seg0;
  int i;
  print(">>> TEST STARTED %s\n", argv[0]);

  print("Testing: %s\n", test_desc);
  
  print("Attaching segment\n");
  seg0 = segattach(0, "shared", 0x0, 4096);
  print("Segment at %x \n", seg0);

  print("Filling segment with 0xAA \n");
  memset(seg0, 0xAA, 4096);

  print("Forking \n");
  i = rfork(RFPROC);

  if (i == 0) {
    print("Child found %x at offset zero of segment \n", seg0[0]);

    print("Child filling segment with 0x01\n");
    memset(seg0, 0x01, 4096);
    print("Child has filled segment with 0x01. goodbye!\n");
    exits("bye");
  }

  sleep(5*100);
  print("Hello from parent again \n");
  print("Expect segment to be filled with 0x01. Got: %x \n", seg0[0]);

  if (seg0[0] != 0x01) {
    print("***** FAILED! \n");
  }

  print(">>> TEST FINISHED %s\n", argv[0]);
}
