#include <u.h>
#include <libc.h>

#define NESEG	2600

char test_desc[] = "Testing attaching and detaching many segments randomly\n";

void main(int argc, char *argv[]){
  char *seg0[NESEG];
  int i;
  int j;
  print(">>> TEST STARTED %s\n", argv[0]);

  print("Testing: %s\n", test_desc);

  print("Starting segattach loop\n");
  for (i = 0; i < NESEG; i++) {
    print("Attaching segment %d\n", i);
    seg0[i] = segattach(0, "memory", nil, 4096);
    if (seg0[i] == nil)
      print("***** Failed at segment %d!\n", i);
  }

  print("Zeroing segments \n");
  for (i = 0; i < NESEG; i++) {
    if (seg0[i]) {
      print("Zeroing %d\n", i);
      memset(seg0[i], 0, 4096);
    }
  }

  print("Detaching segments \n");
  for (i = 0; i < NESEG; i++) {
    print("Detaching segment %d\n", i);
    j = rand() % NESEG;
    segdetach(seg0[j]);
    seg0[j] = 0;
  }

  print("Detaching all segments \n");
  for (i = 0; i < NESEG; i++) {
    segdetach(seg0[i]);
  }

  print(">>> TEST FINISHED %s\n", argv[0]);
}
