#include <u.h>
#include <libc.h>

#define NESEG	164

char test_desc[] = "Testing attaching and detaching many segments, in order\n";

void main(int argc, char *argv[]){
  char *seg0[NESEG];
  char **shrseg;
  int i;
  print(">>> TEST STARTED %s\n", argv[0]);

  print("Testing: %s\n", test_desc);

  print("Attaching scoreboard \n");
  shrseg = segattach(SG_COMMIT, "memory", (void*) 0x40000000, 4096);
  memset(shrseg, 0, 4096);

  print("Starting segattach loop\n");
  for (i = 0; i < NESEG; i++) {
    print("Attaching segment %d\n", i);
    seg0[i] = segattach(SG_COMMIT, "memory", nil, 4096*64);
    if (seg0[i] == nil)
      print("***** Failed at segment %d!\n", i);
  }

  print("Zeroing segments \n");
  for (i = 0; i < NESEG; i++) {
    if (seg0[i]) {
      print("Zeroing %d\n", i);
      memset(seg0[i], 0, 4096);
    }
  }

  print("Copy segment bases\n");
  for (i = 0; i < NESEG; i++) {
     shrseg[i] = seg0[i];
  }

  char *argvv[2];
  argvv[0] = "sgt_aux";
  argvv[1] = nil;

  print("Execing sgt_aux\n");
  exec("./sgt_aux", argvv);

  print(">>> TEST FINISHED %s\n", argv[0]);
}
