#include <u.h>
#include <libc.h>

char test_desc[] = "Testing the ability to write to an R/O segment";

void main(int argc, char *argv[]){
  char *seg0;
  print(">>> TEST STARTED %s\n", argv[0]);

  print("Testing: %s\n", test_desc);

  print("Attaching segment \n");
  seg0 = segattach(SG_RONLY, "shared", nil, 4096);
  if (seg0 == nil)
    print("Unable to get segment\n");
  else
    print("Got seg of addr %x \n", seg0);
  
  if(seg0) {
    print("Filling segment with 0xff. If this test passes, expect suicide\n");
    memset(seg0, 0xFF, 4096);
  }

  print("FAILED! WE SHOULD NOT BE HERE \n");
  while(1);
  
  print(">>> TEST FINISHED %s\n", argv[0]);
}
